//funktioner 
ArrayList<Enemy> enemyList;
ArrayList<Friend> friendList;
ArrayList<Bullet> BulletList;
Rocket rocket = new Rocket (1000, 600); 

int state; 
int score; 

void setup()
{
    size(1000, 600);
    enemyList = new ArrayList<Enemy>();
    friendList = new ArrayList<Friend>();
    BulletList = new ArrayList<Bullet>();
    frameRate(30);
    score = 0;
    state = 0;
    enemyRestart();
}

void draw()
{
    //tilstandene.
    //hvis tilstand = 0 vises start skærmen. 
    //hvis tilstand = 1 begynder spillet. 
    //hvis tilstand = 2 slutter spillet. 
    if (state == 0)
    {
     gameStart();
    }
    if (state == 1){
        game(); 
    }   
    if (state == 2)
    {
        gameOver();
    }

    
}

void game()
{
    //hvis der er under 10 "enemies" så bliver der tilføjet én "enemy". der bliver ikke under 10. 
    if (enemyList.size() < 10) {
        enemyList.add(new Enemy(width, height));
    }

    //hvis der er under 10 "friends" så bliver der tilføjet én "friend". der bliver ikke under 10.
    if (friendList.size() < 10)
    {
        friendList.add(new Friend(width, height));
    }

    background(0); 
    rocket.movement();
    rocket.display();
    textSize(20); 
    text("Score: " + score,20,20); 
    text("HP: " + rocket.rocketHP, 930,20);

    //når kuglen rammer "enemy" så forsvinder den og man får et point. 
    for (int i = BulletList.size()-1; i>=0; i--)
    {
        Bullet localBullet = BulletList.get(i);

        for (int j = enemyList.size()-1; j>=0; j--) {
            Enemy enemy = enemyList.get(j);
            if (localBullet.collideEnemy(enemy)) {
                enemyList.remove(j);
                score = score +1; 
                
            }
        }

        //hvis kuglen er ude af skærmen så bliver den fjernet. 
        if (localBullet.isOutOfWindow()) {
            BulletList.remove(i);
        }

        localBullet.movement(); 
        localBullet.display();
    }



    for (int i = enemyList.size()-1; i>=0; i--)
    {
        Enemy enemy = enemyList.get(i);
        enemy.movement();
        enemy.display(); 

        //hvis man rocket rammer "enemy" så game over. 
        if (rocket.collideEnemy(enemy))
        {
            enemyList.remove(i);
            state = 2;
        }

        //hvis "enemy" er ude af skærmen så bliver den fjernet.
        if (enemy.isOutOfWindow())
        {
            enemyList.remove(i);
        }
    }

    //når kuglen rammer "friend" så forsvinder den og man mister et liv. 
    for (int i = BulletList.size()-1; i>=0; i--)
    {
        Bullet localBullet = BulletList.get(i);

        for (int j = friendList.size()-1; j>=0; j--) {
            Friend friend = friendList.get(j);
            if (localBullet.collideFriend(friend)) {
                friendList.remove(j);
                rocket.rocketHP--;
            }
        }

        //hvis kruglen er ude af skærmen så bliver den fjernet. 
        if (localBullet.isOutOfWindow()) {
            BulletList.remove(i);
        }

        localBullet.movement(); 
        localBullet.display();
    }



    for (int i = friendList.size()-1; i>=0; i--)
    {
        Friend friend = friendList.get(i);
        friend.movement();
        friend.display(); 

        //hvis rocket rammer "friend" så mister man et liv. 
        if (rocket.collideFriend(friend))
        {
            friendList.remove(i);
            rocket.rocketHP--;
        }

        //hvis "friend" er ude af skærmen bliver den fjernet. 
        if (friend.isOutOfWindow())
        {
            friendList.remove(i);
        }
    }
}

void gameStart() //tilstand 0  
{
    background(0); 
    textSize(50); 
    text("START", 420,200);
    textSize(20);
    text("press 'ENTER' to start game", 370,400);
    textSize(25); 
    text("Shoot the right astroid to win the game!", 270, 300); 
}

//game over
void gameOver() //tilstand 2
{
    background(204,0, 0); 
    textSize(50); 
    text("GAME OVER", 350, 300);
    textSize(20);
    text("press 'r' to restart", 410, 330);
}

//restart game 
void enemyRestart()
{
    enemyList.clear(); 
    for (int i = 0; i <  10; i++) {
        enemyList.add(new Enemy(width, height));
    }

    rocket = new Rocket(width, height);
}

//tast bevægelse 
void keyPressed()
{
    rocket.keyPressed();
    if (state == 0 && key == ENTER){
        state = 1;
    }

    if (key == ' ')
    { 
        BulletList.add(new Bullet(rocket.posX, rocket.posY)); 
        println(BulletList.size());
    }


    //tilstand ledelse 
    if (state == 2 && key == 'r') //skrifte til "GAME OVER" tilstand 
    { 
        enemyRestart();
        setup();
    }
}

void keyReleased()
{
    
}
